<template src="./template.html"></template>

<script lang="ts">
import { Component, Prop, Vue, Watch } from "nuxt-property-decorator";
import { apiErrorHandler } from "~/utils/apiHanlers";
import { regexEmail } from "~/common/constaint";
import axios from "axios";
import { objectToParam } from "~/common/utils";
import {
  trackEventAddPaymentInfo,
  trackEventPurchased,
} from "~/utils/trackEvent";
import { getSessionId, randomCharacter, setSessionId } from "~/utils/sessionId";
// @ts-ignore
import countryCode from "~/countries/CountryCodes.json";
import {
  onClearSession,
  onGetCheckoutInfo,
  onSetCheckoutInfo,
} from "~/utils/localStorage";

interface IItemCountry {
  name: string;
  code: string;
}

@Component({
  components: {},
})
export default class PaypalCheckoutComponent extends Vue {
  @Prop()
  couponCode!: string;

  @Prop()
  slug!: string;

  @Prop()
  listCart!: any;

  @Prop()
  checkout!: any;

  @Prop()
  countryCodePayment!: string;

  @Prop()
  amount!: number;

  @Prop()
  totalPriceAll!: number;

  @Prop()
  loadingDiscount!: boolean;

  @Prop()
  isAbandon!: boolean;

  @Prop()
  isSameAddress!: string;

  @Prop()
  errorField: any;

  @Prop()
  isDonePayment!: boolean;

  @Prop()
  tip!: number;

  stripe: any = null;

  countryCode = countryCode;

  messageError = "";

  get myIp() {
    return this.$store?.state?.sitePage?.myIp || {};
  }

  get ip() {
    return this.$store?.state?.sitePage?.ip || "";
  }

  radarSession = "";

  dialogAuthenticate3rd = false;
  urlIFrame = "";

  get publicKeyStripe() {
    // return "sk_test_51N65klFRqDMGudAjJfk6GsEqfpUqtHGYdH4Q4DeSzBqDQwv2GmEQNvWUcKuDAoNaXc1GrDvlAxyPGMDPax6qYNym00Xo314OrX";
    return "pk_test_51N65klFRqDMGudAjg2cho0max9vX5lFweHZMepV03KqJEVvJfpvSCTx30FI6fxgw0ajz9mPEMhWLG3u0MnGVG1zw00BJLDsC7O";
    // return this.$store.state.cart.publicKeyStripeCheckout;
  }

  get serectKey() {
    return this.$store.state.cart.publicKeyStripeCheckout;
  }

  cardNumberFormat = "";
  card = {
    cardNumber: "",
    expiryDate: "",
    cvv: "",
  };

  loading = false;

  cardHolderName = "";
  orderCode = "";
  paymentMethodID = "";
  paymentIntentID = "";
  customerId: any = "";

  errorFieldCard = {
    isCardNumber: "",
    isExpiryDate: "",
    isCvv: "",
    isCardHolderName: "",
  };

  beforeDestroy() {
    this.orderCode = "";
    this.paymentMethodID = "";
    this.paymentIntentID = "";
    if (!this.isDonePayment) {
      onSetCheckoutInfo("card", this.card);
      onSetCheckoutInfo("cardHolderName", this.cardHolderName);
    }
  }

  uppercase() {
    this.cardHolderName = this.cardHolderName.toUpperCase();
  }

  mounted() {
    //@ts-ignore
    const that = this;
    window.addEventListener(
      "message",
      function (ev) {
        if (ev.data === "3DS-authentication-complete") {
          that.dialogAuthenticate3rd = false;
          that.urlIFrame = "";
          if (that.paymentIntentID) {
            that.cardConfirmPayment(that.paymentIntentID);
          }
        }
      },
      false
    );
    //@ts-ignore
    // window.top.postMessage("3DS-authentication-complete");
    // window.addEventListener(
    //   "message",
    //   function (ev) {
    //     if (ev.data === "3DS-authentication-complete") {
    //       console.log("vào đây nè kkk");
    //     }
    //   },
    //   false
    // );
    this.onSetCheckoutInfo();
  }

  async onSetCheckoutInfo() {
    try {
      //@ts-ignore
      const card = JSON.parse(onGetCheckoutInfo("card"));
      this.cardHolderName =
        //@ts-ignore
        JSON.parse(onGetCheckoutInfo("cardHolderName")) || "";
      if (card) {
        this.card = card;
      }
    } catch (error) {
      console.log("error :>> ", error);
    }
  }

  async createPaymentMethod() {
    try {
      this.loading = true;
      this.$gtag.event("form_submissions", {
        value: `${this.listCart[0]?.productName || ""} ${
          this.totalPriceAll || 0
        }`,
        currency: "USD",
      });
      const bodyTrack = {
        productName: this.listCart[0]?.productName || "",
        currency: "USD",
        value: this.totalPriceAll || 0,
      };
      trackEventAddPaymentInfo(this, bodyTrack);

      const stripeKey =
        process.env.NODE_ENV === "development"
          ? "pk_test_51N65klFRqDMGudAjg2cho0max9vX5lFweHZMepV03KqJEVvJfpvSCTx30FI6fxgw0ajz9mPEMhWLG3u0MnGVG1zw00BJLDsC7O"
          : this.serectKey;

      //@ts-ignore
      const stripe = Stripe(stripeKey);
      // Radar

      // const { radarSession, error } = await stripe.createRadarSession();
      // if (error) {
      //   this.trackEventError(error, "createPaymentMethod_radarSession");
      // }
      // this.radarSession = radarSession?.id || "";

      // Customer

      const card = {
        type: "card",
        card: {
          number: this.card.cardNumber,
          exp_month: this.card.expiryDate.split("/")[0],
          exp_year: this.card.expiryDate.split("/")[1],
          cvc: parseInt(this.card.cvv),
        },
      };
      // if (this.radarSession) {
      //   //@ts-ignore
      //   card["radar_options[session]"] = `${this.radarSession}`;
      // }
      const body = objectToParam(card);
      const paymentMethod: any = await this.request({
        path: "payment_methods",
        body,
      });

      // if (paymentMethod?.data?.id) {
      //   this.cardCheckout(paymentMethod.data.id);
      // }
    } catch (error: any) {
      const message =
        error?.response?.data?.message || error?.message || error || "";
      this.trackEventError(message, "createPaymentMethod");
      this.loading = false;
      this.$pushNotification.error(message);
    }
  }

  async cardCheckout() {
    try {
      this.messageError = "";

      if (this.isSameAddress === "0") {
        this.checkout.billingAddress = { ...this.checkout.shippingAddress };
      }
      // if (!this.checkFieldCardBeforePayment()) {
      if (!this.checkErrorField()) return;
      // }

      if (this.checkout.tip < 0)
        return this.$pushNotification.error("Tip cannot be less than 0");

      // if (!paymentMethodID)
      //   return this.$pushNotification.error("PaymentMethodId should not empty");
      this.loading = true;

      this.checkout.shippingAddress.email =
        this.checkout.shippingAddress.email.toLowerCase();

      this.customerId = "";
      const customerId = await this.createCustomer();
      if (customerId) {
        this.customerId = customerId;
      }
      const domain = this.getDomain();

      let cart = [...this.listCart];
      for (let elem of cart) {
        if (!elem.quantity || isNaN(elem.quantity)) {
          this.$pushNotification.error(
            "Number of variants is invalid. Please re-add variant"
          );
          cart = this.listCart.filter(
            (item: any) => !isNaN(item.quantity) && item.quantity > 0
          );
          this.loading = false;
          this.$emit("update:listCart", cart);
          this.$emit("on-get-list");
          return;
        }
      }
      let sessionId = getSessionId();
      if (!sessionId) {
        const charRandom = randomCharacter().toLocaleLowerCase();
        const unixTimeStamp = Math.floor(new Date().getTime() / 1000);
        sessionId = `${charRandom}_${unixTimeStamp}`;
        setSessionId(sessionId);
      }
      const listSelectedProduct = this.listCart.map((variant: any) => ({
        variantSellerId: variant._id,
        quantity: variant.quantity,
      }));

      this.checkout.billingAddress.email =
        this.checkout.shippingAddress.email || "";

      if (this.checkout?.shippingAddress?.state === "Choose your state") {
        this.checkout.shippingAddress.state = "";
      }
      if (this.checkout?.billingAddress?.state === "Choose your state") {
        this.checkout.billingAddress.state = "";
      }

      let body = {
        ...this.checkout,
        ...this.checkout.shippingAddress,
        billingAddress: this.$utils.compare(
          this.checkout.billingAddress,
          this.checkout.shippingAddress
        )
          ? undefined
          : this.checkout.billingAddress,
        couponCode: this.checkout.couponCode || this.couponCode,
        listSelectedProduct,
        countryIp: this.countryCodePayment,
        // paymentMethodID,
        isAbandon: this.isAbandon,
        cardHolderName: this.cardHolderName,
      };
      const query = this.$store.state.sitePage.utm || {};
      const checkoutMethod = await this.$api.order.cardCheckout(
        body,
        domain,
        query,
        sessionId
      );
      if (checkoutMethod.data) {
        this.orderCode = checkoutMethod.data.orderCode;
        this.createPaymentIntents();
      }
    } catch (error: any) {
      const message =
        error?.response?.data?.message || error?.message || error || "";
      this.trackEventError(message, "cardCheckout");
      this.$sentry.captureException(
        error.response?.data || "An error occurred"
      );
      this.loading = false;
      apiErrorHandler(error, this);
    }
  }

  async createPaymentIntents() {
    try {
      // if (!paymentMethodID)
      //   return this.$pushNotification.error("PaymentMethodId should not empty");
      const domain = this.getDomain();
      const { shippingAddress, billingAddress } = this.checkout;

      const http = process.env.NODE_ENV === "development" ? "http" : "https";
      const ip = this.ip || "";
      const stateBilling =
        billingAddress?.state === "Choose your state"
          ? undefined
          : billingAddress?.state;
      const findCountryCode = this.countryCode.find(
        (item: IItemCountry) =>
          item.name === this.checkout.billingAddress.country
      );

      let payload: any = {
        amount: Math.round(this.totalPriceAll * 100),
        currency: "usd",
        // payment_method: paymentMethodID,

        "payment_method_data[user_agent]": navigator.userAgent,
        "payment_method_data[type]": "card",
        "payment_method_data[card][number]": this.card.cardNumber,
        "payment_method_data[card][exp_month]":
          this.card.expiryDate.split("/")[0],
        "payment_method_data[card][exp_year]":
          this.card.expiryDate.split("/")[1],
        "payment_method_data[card][cvc]": this.card.cvv,

        setup_future_usage: "on_session",
        "automatic_payment_methods[enabled]": "true",
        "automatic_payment_methods[allow_redirects]": "never",
        "payment_method_options[card][request_three_d_secure]": "any",
        "shipping[name]": `${shippingAddress?.firstName || ""} ${
          shippingAddress?.lastName || ""
        }`,
        "shipping[phone]": shippingAddress?.phoneNumber || "",
        "shipping[address][city]": `${shippingAddress?.city || ""}`,
        "shipping[address][country]": `${shippingAddress?.country || ""}`,
        "shipping[address][line1]": `${shippingAddress?.address || ""}`,
        "shipping[address][line2]":
          shippingAddress?.apartment || ""
            ? `${shippingAddress?.apartment || ""}`
            : undefined,
        "shipping[address][postal_code]": `${shippingAddress?.zipCode || ""}`,
        "shipping[address][state]": `${shippingAddress?.state || ""}`,

        "payment_method_data[billing_details][email]":
          billingAddress?.email || "",
        "payment_method_data[billing_details][name]": `${
          billingAddress?.firstName || ""
        } ${billingAddress?.lastName || ""}`,
        "payment_method_data[billing_details][phone]":
          billingAddress?.phoneNumber || "",
        "payment_method_data[billing_details][address][city]": `${
          billingAddress?.city || ""
        }`,

        "payment_method_data[billing_details][address][line1]": `${
          billingAddress?.address || ""
        }`,
        "payment_method_data[billing_details][address][line2]":
          billingAddress?.apartment || ""
            ? `${billingAddress?.apartment || ""}`
            : undefined,
        "payment_method_data[billing_details][address][postal_code]": `${
          billingAddress?.zipCode || ""
        }`,

        "metadata[order_id]": `${this.orderCode}`,
        "metadata[domain]": `${domain}`,
        return_url: this.slug
          ? `${http}://${window.location.host}/${this.slug}/checkout/stripe-3ds?stripe=redirectToSite`
          : `${http}://${domain}/checkout/stripe-3ds?stripe=redirectToSite`,
        confirm: "true",
      };

      if (this.customerId) {
        payload["customer"] = this.customerId;
      }

      if (ip) {
        payload["payment_method_data[ip]"] = ip;
      }

      if (stateBilling) {
        payload["payment_method_data[billing_details][address][state]"] =
          stateBilling;
      }

      if (findCountryCode && findCountryCode.code) {
        payload["payment_method_data[billing_details][address][country]"] =
          findCountryCode.code;
      }

      // if (this.radarSession) {
      //   //@ts-ignore
      //   payload["radar_options[session]"] = `${this.radarSession}`;
      // }

      const body = objectToParam(payload);
      const paymentIntent: any = await this.request({
        path: "payment_intents",
        body,
      });

      if (!paymentIntent || !paymentIntent.data) return;

      this.paymentMethodID = paymentIntent?.data?.payment_method || "";
      this.paymentIntentID = paymentIntent?.data?.id || "";

      if (paymentIntent.data?.next_action?.redirect_to_url?.url) {
        this.dialogAuthenticate3rd = true;
        this.urlIFrame = paymentIntent.data.next_action.redirect_to_url.url;
      } else {
        if (!this.paymentIntentID)
          return this.$pushNotification.error("Unable to initialize payment");

        this.cardConfirmPayment(this.paymentIntentID);
      }
    } catch (error: any) {
      const message =
        error?.response?.data?.message || error?.message || error || "";
      this.trackEventError(message, "createPaymentIntents");
      this.loading = false;
      this.onDeleteOrder(this.orderCode);
    }
  }

  async cardConfirmPayment(paymentIntentID: string) {
    try {
      const domain = this.getDomain();
      const response = await this.$api.order.confirmPayment(
        {
          orderCode: this.orderCode,
          paymentMethodID: this.paymentMethodID,
          paymentIntentID,
        },
        domain
      );
      if (response?.data) {
        this.$gtag.event("purchase", {
          event_label: `purchase stripe`,
          currency: "USD",
        });
        const bodyTrack = {
          quantity: this.amount || 1,
          total: this.totalPriceAll || 1,
          productName: this.listCart[0]?.productName || "",
          listSelectedProduct: this.listCart.map((cart: any) => ({
            orderCode: response?.data?.orderCode || "",
            quantity: cart.quantity || 1,
            price: cart.price || 1,
          })),
          email: response?.data?.email || "",
          phoneNumber: response?.data?.phoneNumber || "",
          orderCode: response?.data?.orderCode || "",
        };
        trackEventPurchased(this, bodyTrack);
        this.$emit("update:isDonePayment", true);
        localStorage.setItem("tip", JSON.stringify(this.tip));
        this.$router.push(
          `${this.slug ? `/${this.slug}` : ""}/order-success?email=${
            response?.data?.email || ""
          }&order_code=${response.data.orderCode.replace("#", "")}`
        );
        this.$store.commit("cart/setListCart", []);
        localStorage.setItem("cart", JSON.stringify([]));
      }
    } catch (error: any) {
      const message =
        error?.response?.data?.error?.message ||
        error?.response?.data?.message ||
        error?.message ||
        error ||
        "";
      if (message) {
        this.messageError = message.replaceAll(".", "");
      }
      this.trackEventError(message, "cardConfirmPayment");
      this.$sentry.captureException(
        error.response?.data || "An error occurred"
      );
      // this.$pushNotification.error(message);
    } finally {
      this.loading = false;
    }
  }

  getDomain() {
    return this.$store.state?.product?.domain || "";
  }

  async request({ path, body }: { path: string; body?: any }) {
    const url = `https://api.stripe.com/v1/${path}`;
    return await axios({
      method: "post",
      url,
      headers: {
        Authorization: `Bearer ${this.serectKey}`,
        "Content-Type": "application/x-www-form-urlencoded",
      },
      data: body,
    })
      .then((response) => response)
      .catch((error: any) => {
        const message =
          error?.response?.data?.error?.message ||
          error?.response?.data?.message ||
          error?.message ||
          error ||
          "";
        if (message) {
          this.messageError = message.replaceAll(".", "");
        }
        this.trackEventError(message, `request | ${path}`);
        this.$pushNotification.error(
          error.response?.data?.error?.message || "An error occurred"
        );
        this.$sentry.captureException(
          error.response?.data || "An error occurred"
        );
        this.loading = false;
      });
  }

  createCustomer() {
    return new Promise(async (resolve, reject) => {
      try {
        const {
          email,
          firstName,
          lastName,
          phoneNumber,
          address,
          city,
          state,
          zipCode,
          apartment,
          country,
        } = this.checkout.shippingAddress;
        const customer = {
          email,
          phone: phoneNumber,
          name: `${firstName} ${lastName}`,
          "address[city]": city,
          "address[country]": country,
          "address[line1]": `${address}`,
          "address[line2]": apartment ? `${apartment}` : undefined,
          "address[postal_code]": `${zipCode}`,
          "address[state]": `${state}`,
        };
        const body = objectToParam(customer);
        const response: any = await this.request({
          path: "customers",
          body,
        });

        if (response?.data?.id) {
          resolve(response.data.id);
        }
        reject(new Error("Create customer fail"));
      } catch (error) {
        reject(new Error("Create customer fail"));
      }
    });
  }

  trackEventError(message: string, nameFc: string) {
    this.$gtag.event("purchase fail", {
      error: message,
      event_label: nameFc,
    });
    this.$sentry.captureException(message || "An error occurred");
  }

  async onDeleteOrder(orderCode: string) {
    try {
      this.$axios.setHeader(
        "secret",
        "RtV30HXkxzgdV3SX83XK4UuR7k2z9mtZ0Kxo1DYkHpt4CLF9gPM4u7ysa0cWIWwXqJUCSVut7gIouorFSrbVuejy5HghYdr9TQLm"
      );
      await this.$api.order.deleteOrder(orderCode);
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  checkFieldCardBeforePayment() {
    const { email, firstName, lastName, address, country, phoneNumber } =
      this.checkout.shippingAddress;
    if (
      !(email && firstName && lastName && address && country && phoneNumber)
    ) {
      return false;
    }

    if (this.isSameAddress === "1") {
      const { firstName, lastName, address, country, phoneNumber } =
        this.checkout.billingAddress;
      if (!(firstName && lastName && address && country && phoneNumber)) {
        return false;
      }
    }

    const { cardNumber, expiryDate, cvv } = this.card;
    if (!(cardNumber && expiryDate && cvv && this.cardHolderName)) return false;
    return true;
  }

  resetField() {
    return {
      shippingAddress: {
        isEmail: "",
        isFirstName: "",
        isLastName: "",
        isAddress: "",
        isZipCode: "",
        isCity: "",
        isState: "",
        isPhoneNumber: "",
      },
      billingAddress: {
        isEmail: "",
        isFirstName: "",
        isLastName: "",
        isAddress: "",
        isZipCode: "",
        isCity: "",
        isState: "",
        isPhoneNumber: "",
      },
    };
  }

  resetFieldCard() {
    return (this.errorFieldCard = {
      isCardNumber: "",
      isExpiryDate: "",
      isCvv: "",
      isCardHolderName: "",
    });
  }

  checkErrorField() {
    try {
      const errorField: any = this.resetField();

      // Check shipping error
      for (let item in this.checkout.shippingAddress) {
        let textFieldUppercase = `${
          item.charAt(0).toUpperCase() + item.slice(1)
        }`;
        if (item === "apartment") {
          continue;
        }
        if (
          item === "state" &&
          this.checkout.shippingAddress.country !== "United States" &&
          this.checkout.shippingAddress.country !== "Canada" &&
          this.checkout.shippingAddress.country !== "Australia"
        ) {
          continue;
        }
        if (
          !this.checkout.shippingAddress[item] ||
          this.checkout.shippingAddress[item] === "Choose your state"
        ) {
          if (item === "email") {
            errorField.shippingAddress[
              `is${textFieldUppercase}`
            ] = `"Email" is not allowed to be empty`;
          } else {
            errorField.shippingAddress[
              `is${textFieldUppercase}`
            ] = `Please fill this required field`;
          }
        } else {
          errorField.shippingAddress[`is${textFieldUppercase}`] = "";
        }
      }

      // Check billing error
      if (this.isSameAddress === "1") {
        for (let item in this.checkout.billingAddress) {
          let textFieldUppercase = `${
            item.charAt(0).toUpperCase() + item.slice(1)
          }`;
          if (item === "apartment" || item === "email") {
            continue;
          }
          if (
            item === "state" &&
            this.checkout.billingAddress.country !== "United States" &&
            this.checkout.billingAddress.country !== "Canada" &&
            this.checkout.billingAddress.country !== "Australia"
          ) {
            continue;
          }
          if (
            !this.checkout.billingAddress[item] ||
            this.checkout.billingAddress[item] === "Choose your state"
          ) {
            if (item === "email") {
              errorField.billingAddress[
                `is${textFieldUppercase}`
              ] = `"Email" is not allowed to be empty`;
            } else {
              errorField.billingAddress[
                `is${textFieldUppercase}`
              ] = `Please fill this required field`;
            }
          } else {
            errorField.billingAddress[`is${textFieldUppercase}`] = "";
          }
        }
      }

      // Check email error
      if (!regexEmail.test(this.checkout.shippingAddress.email)) {
        errorField.shippingAddress.isEmail = '"Email" must be a valid email';
      }

      const isCheckCard = this.checkErrorFieldCard();
      this.$emit("update:errorField", errorField);

      if (!isCheckCard) return false;
      for (let item in errorField.shippingAddress) {
        if (errorField.shippingAddress[item]) return false;
      }

      if (this.isSameAddress === "1") {
        for (let item in errorField.billingAddress) {
          if (errorField.billingAddress[item]) return false;
        }
      }

      return true;
    } catch (error) {
      console.log("error :>> ", error);
    }
  }

  checkErrorFieldCard() {
    try {
      this.errorFieldCard = this.resetFieldCard();
      if (!this.cardHolderName) {
        this.errorFieldCard.isCardHolderName = "Name is required";
      }
      if (!this.card.cardNumber) {
        this.errorFieldCard.isCardNumber = "Card number is required";
      }
      if (!this.card.expiryDate) {
        this.errorFieldCard.isExpiryDate = "Expiry date is required";
      }
      if (!this.card.cvv) {
        this.errorFieldCard.isCvv = "CVV number is required";
      }

      for (let item in this.errorFieldCard) {
        //@ts-ignore
        if (this.errorFieldCard[item]) return false;
      }

      return true;
    } catch (error) {
      console.log("error :>> ", error);
    }
  }

  card_format(value: string) {
    value = value.toString();
    var v = value.replace(/\s+/g, "").replace(/[^0-9]/gi, "");
    var matches = v.match(/\d{4,16}/g);
    var match = (matches && matches[0]) || "";
    var parts = [];

    for (let i = 0, len = match.length; i < len; i += 4) {
      parts.push(match.substring(i, i + 4));
    }

    if (parts.length) {
      return parts.join(" ");
    } else {
      return value;
    }
  }

  cardType = "";

  GetCardType() {
    const cardNumber = this.card.cardNumber.replaceAll(" ", "");
    // visa
    var re = new RegExp("^4");
    if (cardNumber.match(re) != null) return (this.cardType = "Visa");

    // Mastercard
    // Updated for Mastercard 2017 BINs expansion
    if (
      /^(5[1-5][0-9]{14}|2(22[1-9][0-9]{12}|2[3-9][0-9]{13}|[3-6][0-9]{14}|7[0-1][0-9]{13}|720[0-9]{12}))$/.test(
        cardNumber
      )
    )
      return (this.cardType = "Mastercard");

    // AMEX
    re = new RegExp("^3[47]");
    if (cardNumber.match(re) != null) return (this.cardType = "AMEX");

    // Discover
    re = new RegExp(
      "^(6011|622(12[6-9]|1[3-9][0-9]|[2-8][0-9]{2}|9[0-1][0-9]|92[0-5]|64[4-9])|65)"
    );
    if (cardNumber.match(re) != null) return (this.cardType = "Discover");

    // Diners
    re = new RegExp("^36");
    if (cardNumber.match(re) != null) return (this.cardType = "Diners");

    // Diners - Carte Blanche
    re = new RegExp("^30[0-5]");
    if (cardNumber.match(re) != null)
      return (this.cardType = "Diners - Carte Blanche");

    // JCB
    re = new RegExp("^35(2[89]|[3-8][0-9])");
    if (cardNumber.match(re) != null) return (this.cardType = "JCB");

    // Visa Electron
    re = new RegExp("^(4026|417500|4508|4844|491(3|7))");
    if (cardNumber.match(re) != null) return (this.cardType = "Visa Electron");

    this.cardType = "";
  }

  @Watch("card.cardNumber")
  async onPropertyChangedCardNumber(cardNumber: string) {
    const listNumber = cardNumber.split("");
    const remainNumber = listNumber.filter((char) => {
      if (char == " ") {
        return char;
      }
      if (!isNaN(parseInt(char))) {
        return char;
      }
    });
    const onlyNumber = remainNumber.filter((n) => n).join("");
    const formatNumber = this.card_format(onlyNumber);
    this.$nextTick(() => {
      this.card.cardNumber = formatNumber;
    });
  }

  @Watch("card.expiryDate")
  async onPropertyChangedCardDate(value: string) {
    this.card.expiryDate = this.card.expiryDate
      .replaceAll("/", "")
      .replace(/\B(?=(\d{2})+(?!\d))/g, "/");
  }
}
</script>

<style src="../style.scss" lang="scss" scoped></style>
